<?
/*
-----------------------------------------------------

Modulo: Script Indexador
Descripcion: Indexar los posts, con TAGs.
Entrada: f= forum number; t= que buscar (1:(COM) - 2: (PED)); l= (letra)  [l es un parametro opcional]
         ejemplo 1: indexa_html.php?f=5&t=1&l=d
		 ejemplo 2: indexa_html.php?f=31&t=1
Autor: snoop852@gmail.com ( para argentop2p.com.ar )
Fecha: 08/12/05 -
Modificado completamente por:
  Predicador (25.01.2006)
  [kiuman@gmail.com]

-----------------------------------------------------
Por favor, no cambien los copyleft correspondientes.
Bajo Licencia GPL v2
http://www.gnu.org/licenses/gpl.txt
-----------------------------------------------------
*/

# **************** Variables que se pueden cambiar *********

# Nombre del archivo de salida
# Se complmeneta con el numero del foro y luego .html o _x.html siendo x una letra.
# Ejemplo: para foro 5 y letra a (indexa_html.php?f5&t=1&l=a)  sera: listado5_a.html
$archivo = "listado";
# nombre del archivo con las novedades solas en formato TXT (no poner nombre para que no se genere)
$irctxt = "../novedades";

# Por cuantos dias algo se considera nuevo.
$diasNuevo = "7";


# **************** A partir de aca nada se deberia cambiar *********

# Variables globales de la DB y del foro
# $db_server,  $db_user,  $db_passwd, $db_name, $boardurl
require_once('../Settings.php');

$version = "1 beta.";
$ircnov = "";

// Funcion que elimina ciertas palabras del una cadena (case-insensitive)
// added by Predicador
function limpiaCOM($cadena)
{
 // Lista de palabras a eliminar
        $pal_a_eliminar = array("\(url\)",
                                                        "\(ped\)",
                                                        "\(com\)",
                                                        "\[com\]",
                                                        "\(arg\)",
                                                        "\[arg\]",
                                                        "\(documental\)",
                                                        "\[pack\]",
                                                        "\[vid\]",
                                                        "\(vid\)",
                                                        "\[doc\]",
                                                        "\(doc\)",
                                                        "\(pack\)",
                                                        "\[pack\]",
                                                        "\[lat\]",
                                                        "\[esp\]",
                                                        "\[xxx\]",
                                                        "\[inf\]",
                                                        "\[ed2k\]",
                                                        "\(ed2k\)",
                                                        "\[BT\]",
                                                        "\(BT\)",
                                                        "\[DD\]",
                                                        "\(DD\)",
                                                        "\(juego\)",
                                                        "\[juego\]",
                                                        "\(juegos\)",
                                                        "\[juegos\]",
                                                        "\(game\)",
                                                        "\[game\]",
                                                        "\(P2M\)",
                                                        "\[P2M\]",
                                                        "\(PC\)",
                                                        "\(PS2\)",
														"\(soft\)",
														"\[soft\]",
														"\(otros\)",
														"\[otros\]",
														"\(video\)",
														"\[video\]",
														"\(varios\)",
														"\[varios\]",
                                                        "\(documentales\)");

 foreach ($pal_a_eliminar as $una_palabra)
    $cadena = eregi_replace($una_palabra, "", $cadena);

 // Solo funciona en php 5.0 y es mas eficiente
 // $cadena = str_ireplace($pal_a_eliminar, "", $cadena);
 return trim($cadena);
}

// Imprime el titulo de los caracteres
// added by Predicador
function construyeLetra($cad){
  return "<br><br>\n   <span style=\"font-weight: bold\"><span style=\"font-size: 18px; line-height: normal\"><a name=\"_".$cad."\">Letra ".$cad."</a></span></span>\n <br>\n";
}

/* Funcion para conectarse con la base */
function Conectarse($host, $usr, $pass, $bd)
{
   if (!($link=mysql_connect($host, $usr, $pass)))
   {
      echo "Error conectando a la base de datos.";
      exit();
   }
   if (!mysql_select_db($bd,$link))
   {
      echo "Error seleccionando la base de datos.";
      exit();
   }
   return $link;
}

# Parsing de los parametros recibidos
if (is_numeric($HTTP_GET_VARS["t"])) 
{
        $intBusca = intval($HTTP_GET_VARS["t"]);
        switch ($intBusca)
        {
                case 1 : $cadenaBusca = "(COM)";
                        break;
                case 2 : $cadenaBusca = "(PED)";
            break;
                default : $cadenaBusca = "(COM)";
   }
} 
else 
{
        exit("Tratando de cagarme?<br> Por las dudas guardo tu IP.<br>");  # solo para asustar
}

if (is_numeric($HTTP_GET_VARS["f"])) 
{
        $foro = intval($HTTP_GET_VARS["f"]);
} 
else 
{
        exit("Tratando de cagarme?<br> Por las dudas guardo tu IP.<br>");  # solo para asustar
}
# Fin parsing de parametros recibidos

#*******************************************
#              EXPERIMENTAL
# Si anda bien luego se embellece el codigo y se hace mas eficiente
# En fin, es el parsing y armado de query si es que pide por una letra, sino normal
#*******************************************
$letra = substr($HTTP_GET_VARS["l"],0,1);
if (preg_match("/[a-z0-9]/i", $letra))
{  
    # si hay una letra o numero
    # este MySQL no soporta expresiones regulares, asi que a hacer las cosas a mano LPM!
    # $condicion = "REGEX '[(]com[)]([[:space:]]*)".$letra."'";
    $letra = strtolower($letra);
    $archivo = $archivo . "_" . $letra;
	# SMF 1.1 RC2
    $SQL =  "SELECT y.id_topic, y.id_board, y.id_first_msg, y.id_member_started, x.id_msg, x.subject, x.id_topic, x.id_board, x.id_member, x.posterName, x.posterTime, z.id_board, z.name ";        
    $SQL = $SQL . "FROM smf_messages x, smf_topics y, smf_boards z WHERE y.id_member_started=x.id_member AND x.id_board=z.id_board AND y.id_board='".$foro."' ";
    $SQL = $SQL . "AND ((subject LIKE '".$cadenaBusca.$letra."%') OR (subject LIKE '".$cadenaBusca." ".$letra."%'))";
	
	# phpBB 2.0.19 version:
	# $SQL =  "SELECT y.user_id, y.username, x.topic_title, x.topic_id, x.forum_id, x.topic_poster ";
    # $SQL = $SQL . "FROM phpbb_topics x, phpbb_users y WHERE y.user_id=x.topic_poster AND forum_id='".$foro."'";
    # $SQL = $SQL . "AND ((topic_title LIKE '".$cadenaBusca.$letra."%') OR (topic_title LIKE '".$cadenaBusca." ".$letra."%'))";
} 
else 
{
    # SMF 1.1 RC2
	$SQL="SELECT y.id_topic, y.id_board, y.id_first_msg, x.id_msg, x.subject, x.id_topic, x.id_board, x.posterName, x.posterTime, z.id_board, z.name FROM smf_messages x, smf_topics y, smf_boards z WHERE y.id_first_msg=x.id_msg AND x.id_board=z.id_board AND x.id_board='".$foro."' AND subject LIKE '".$cadenaBusca."%'";

	# phpBB 2.0.19 version:
    # $SQL="SELECT y.user_id, y.username, x.topic_title, x.topic_id, x.forum_id, x.topic_poster FROM phpbb_topics x, phpbb_users y WHERE y.user_id=x.topic_poster AND forum_id='".$foro."' AND topic_title LIKE '".$cadenaBusca."%'";
}


#*******************************************
#           FIN  EXPERIMENTAL
#*******************************************


# Conexion a la base de datos
conectarse($db_server, $db_user, $db_passwd,$db_name) or exit("Se ha producido un error al conectarse");


# ---------------------- Comienzo codigo nuevo -------------------------

 $rs = mysql_query($SQL) or exit("Se ha producido un error al ejecutar la consulta\n" .$SQL);

 // incializamos el array
 $index = array();

while ($datos = mysql_fetch_array($rs)) 
{
    // separado el titulo en variable para poder filtrarlo y los demas por comodidad
    $titulo= limpiaCOM($datos[subject]);
    $topicId = $datos[id_topic];
    $usuario = $datos[posterName];
    $boardName = $datos[name];
	$postTime = $datos[posterTime];
    // se construye un arreglo con cada linea
    $index[] = array("titulo" => $titulo, "usuario" => $usuario, "topicId" => $topicId, "ptime" => $postTime);
}
mysql_free_result($rs);
mysql_close();

 // ordenemos el arreglo por titulo
foreach($index as $temporal)
        $AuxArray[] = strtolower($temporal['titulo']);
        array_multisort($AuxArray, SORT_ASC, $index);

# Abrimos el archivo
# Si ya existe se destruye
$archivo = $archivo . $foro . ".html";
if ($handle = fopen($archivo, "w"))
{
    //abrio bien (jejeje, deberia estructurar esto bien, asi apesta!)
} else
{
    exit("Error groso al abrir el archivo. ". $archivo . " no es writable, fijate los permisos.");
}


// Generamos el header del HTML
# Unos headers HTML por si no queremos incluirlo dentro de un modulo
# fwrite($handle, "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\"\n         \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n");
# fwrite($handle, "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">\n");
# fwrite($handle, "<head>\n  <meta http-equiv=\"content-type\" content=\"text/html; charset=iso-8859-1\" />\n  <meta http-equiv=\"Pragma\" content=\"no-cache\" />\n");
# fwrite($handle, "  <meta content=\"no-cache\" http-equiv=\"no-cache\" />\n  <meta http-equiv=\"Cache-Control\" content=\"no-cache\" /> ");
# fwrite($handle, "  <meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n  <meta http-equiv=\"Content-Style-Type\" content=\"text/css\">\n");
# fwrite($handle, "  <title>ARGENTOP2P :: Indexer</title>\n  <link rel=\"stylesheet\" href=\"templates/subSilver/subSilver.css\" type=\"text/css\">\n</head>\n<body>\n");

fwrite($handle, "   <span style=\"font-size: 18px; line-height: normal; font-weight: bold\">Indice de links del foro:   ". $boardName ."<br></span>\n");
fwrite($handle, "   <span style=\"font-size: 10px; line-height: normal\">Generado el ". date("d.m.y  \a\ \l\a\s H:i:s")."</span><br><br>\n");
fwrite($handle, "   <span style=\"font-size: 12px; line-height: normal\">Las lineas marcadas con <img src=/list/new.png> corresponden a posts entre el ". date("d.m.y", (time() - ($diasNuevo * 24 * 60 * 60)))." y ". date("d.m.y") .".</span><br><br>\n");


// imprimimos el Indice en un archivo
if (!$letra)
{
        $indice = "<a href=\"#_#\" class=\"postlink\">#</a> <a href=\"#_[\">[</a> ";
        for ($le = 65; $le <= 90; $le++) // de A a Z
                $indice .= "<a href=\"#_".chr($le)."\">".chr($le)."</a> ";
    fwrite($handle,$indice);
}

 // imprimimos las peliculas y sus links
 $cantPelis = 0;
 $ultimaLetra = "";
 $letraActual  = "";
 $fueNumero = false;
 foreach ($index as $data) 
 {
    $letraActual = strtolower(substr($data[titulo], 0, 1));
    if ($ultimaLetra != $letraActual) 
    {
        // reemplazar por un preg_match("/[0-9]/", $letraActual)
        if (($letraActual <= "9") and !($fueNumero)) 
        {
            fwrite($handle, construyeLetra("#"));
            $fueNumero = true;
        } 
        else 
        {
            // reemplazar por un preg_match("/[a-z]/i", $letraActual)
            if (( "a" <= $letraActual) and ($letraActual <= "z")) 
            {
                fwrite($handle, construyeLetra(strtoupper($letraActual)));
            }
            else 
            {
                if ( $letraActual == "[") 
                {
                    //$packActual = strtolower(substr($data[titulo], 0, 4));
                    fwrite($handle, construyeLetra(strtoupper($letraActual)));
                }
            }
        }
    }
    $cantPelis = $cantPelis + 1;
	fwrite($handle, "     <img src=/Smileys/argentos/icon_arrow.gif> ");
    // here we test if it's a new link or not ;) (the post is newer than $diasNuevo)
	if ($data[ptime] >= (time() - ($diasNuevo * 24 * 60 * 60))) {
	   fwrite($handle, "<img src=/list/new.png> ");
	   # here the new stuff is stored to be written to a TXT file to read from IRC
	   $ircnov .= "Novedad ED2K: ". $data[titulo] ." posteada por ". $data[usuario]. ". Link: $boardurl/index.php?topic=". $data[topicId]."\n";
	   
	}
	fwrite($handle, "<a href=$boardurl/index.php?topic=". $data[topicId] ." target=_blank>". $data[titulo] ."</a><em> - (". $data[usuario] .")</em><br>\n");
    $ultimaLetra = $letraActual;
 }
 fwrite($handle, "<br><br><span style=\"font-weight: bold\">:.:: Total de links publicados: ". $cantPelis ."</span><br>\n");
 fwrite($handle, "<span style=\"font-size: 10px; line-height: normal\">::.: IndexA version ". $version ." by ArgentoP2P.net Coders Team :: 2006 </span>\n");
 
 // Se cierra el HTML por si no habiamos elegido incluirlo dentro de un modulo
 // fwrite($handle,"</body></html>"); 
 
 fclose($handle);
 
 // just write the TXT if there's a file and forum is 5 or 31 (peliculas y series ed2k en argentop2p [respectivamente]). 
 if ($irctxt != ""){
    if ($foro == 5 || foro == 31) {
	   $irctxt .= $foro . ".txt";
	   if ($handle = fopen($irctxt, "w")){
          fwrite($handle,$ircnov);
          fclose($handle);
       } else {
       exit($irctxt . " no es writable, fijate los permisos.");
       }
	}
 }
 
# ---------------------- Fin codigo nuevo -------------------------
 echo "El proceso se ha completado sin errores.<br>";
 echo "Indice del foro ". $boardName . " generado";

?>

